﻿using System.Collections;
using Kreta.Framework.Entities;

namespace Kreta.Framework.Collections
{
    public interface IEntityCollection : IEnumerable
    {
        int Count
        {
            get;
        }

        Entity this[int index]
        {
            get;
        }

        int Add(Entity entity);

        bool Contains(Entity entity);

        void DeleteAll();

        void DeleteAll(bool runHandler);

        void CascadeDeleteAll();

        void CascadeDeleteAll(bool runHandler);

        Entity FindEntityById(int entityId);

        void Clear();

        int IndexOf(Entity entity);
    }
}
